var TSUI;
(function (TSUI) {
    (function (Animation) {
        var SelectionWindowAnimator = (function () {
            function SelectionWindowAnimator() {
            }
            SelectionWindowAnimator.prototype.Show = function (control, callback) {
                if (typeof callback === "undefined") { callback = null; }
                $(".SelectionWindow_DisableOverlay").css({
                    display: "block",
                    opacity: 0,
                    zIndex: (TSUI.UI.OpenWindows * 10) - 1
                }).animate({
                    opacity: 0.6
                }, 200, "swing", function () {
                });

                var oldOpacity = control.GetStyle("opacity");
                control.AnimationElement().stop(true, true);
                control.AnimationElement().css({
                    opacity: 0,
                    visibility: "",
                    display: ""
                }).animate({
                    opacity: oldOpacity
                }, SelectionWindowAnimator.AnimationTime, SelectionWindowAnimator.AnimationEasing, function () {
                    if (callback !== null) {
                        callback();
                    }
                });
            };

            SelectionWindowAnimator.prototype.Hide = function (control, callback) {
                if (typeof callback === "undefined") { callback = null; }
                $(".SelectionWindow_DisableOverlay").animate({
                    opacity: 0
                }, 200, "swing", function () {
                    $(this).css({
                        display: ""
                    });
                });

                control.AnimationElement().stop(true, true);
                control.AnimationElement().animate({
                    opacity: 0
                }, SelectionWindowAnimator.AnimationTime, SelectionWindowAnimator.AnimationEasing, function () {
                    control.AnimationElement().css({
                        visibility: "hidden",
                        opacity: 1,
                        display: "none"
                    });
                    if (callback !== null) {
                        callback();
                    }
                });
            };
            SelectionWindowAnimator.AnimationTime = 250;

            SelectionWindowAnimator.AnimationEasing = "easeOutQuad";
            return SelectionWindowAnimator;
        })();
        Animation.SelectionWindowAnimator = SelectionWindowAnimator;
    })(TSUI.Animation || (TSUI.Animation = {}));
    var Animation = TSUI.Animation;
})(TSUI || (TSUI = {}));
